Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/ComponentRegistryFactoryDbImpl.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/ComponentRegistryFactoryDbImpl.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/ComponentRegistryFactoryDbImpl.java	(revision 5549)
@@ -3,8 +3,8 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
-import clarin.cmdi.componentregistry.ComponentStatus;
 import clarin.cmdi.componentregistry.Configuration;
 import clarin.cmdi.componentregistry.Owner;
 import clarin.cmdi.componentregistry.OwnerUser;
+import clarin.cmdi.componentregistry.RegistrySpace;
 import clarin.cmdi.componentregistry.UserCredentials;
 import clarin.cmdi.componentregistry.UserUnauthorizedException;
@@ -25,5 +25,5 @@
  * ComponentRegistryDbImpl implementation of ComponentRegistry for accessing the
  * registry
- * 
+ *
  * @author Twan Goosen <twan.goosen@mpi.nl>
  * @author George.Georgovassilis@mpi.nl
@@ -32,5 +32,5 @@
 
     private final static Logger LOG = LoggerFactory
-	    .getLogger(ComponentRegistryFactoryDbImpl.class);
+            .getLogger(ComponentRegistryFactoryDbImpl.class);
     @Autowired
     private Configuration configuration;
@@ -43,141 +43,169 @@
     @Override
     public List<ComponentRegistry> getAllUserRegistries() {
-	// TODO: this probably could use some caching
-	try {
-	    List<RegistryUser> users = userDao.getAllUsers();
-	    List<ComponentRegistry> registries = new ArrayList<ComponentRegistry>();
-	    for (RegistryUser user : users) {
-		registries.add(getNewComponentRegistryForUser(user.getId()));
-	    }
-	    return registries;
-	} catch (DataAccessException ex) {
-	    LOG.error("Could not retrieve users", ex);
-	    throw ex;
-	}
-    }
-
-    @Override
-    public ComponentRegistry getComponentRegistry(ComponentStatus status,
-	    Owner owner, UserCredentials credentials)
-	    throws UserUnauthorizedException {
-	switch (status) {
-	case PRIVATE:
-	    return getPrivateRegistry(owner, credentials);
-	case PUBLISHED:
-	    return getPublicRegistry();
-	default:
-	    // TODO: Add support for other status types
-	    throw new UnsupportedOperationException(
-		    "Unsupported component status" + status);
-	}
+        // TODO: this probably could use some caching
+        try {
+            List<RegistryUser> users = userDao.getAllUsers();
+            List<ComponentRegistry> registries = new ArrayList<ComponentRegistry>();
+            for (RegistryUser user : users) {
+                registries.add(getNewComponentRegistryForUser(user.getId()));
+            }
+            return registries;
+        } catch (DataAccessException ex) {
+            LOG.error("Could not retrieve users", ex);
+            throw ex;
+        }
+    }
+
+    @Override
+    public ComponentRegistry getComponentRegistry(RegistrySpace space,
+            Owner owner, UserCredentials credentials, Number groupId)
+            throws UserUnauthorizedException {
+
+        switch (space) {
+            case PRIVATE:
+                return this.getPrivateRegistry(owner, credentials);
+            case PUBLISHED:
+                return this.getPublicRegistry();
+            case GROUP:
+                return this.getGroupRegistry(groupId, owner, credentials);
+            default:
+                // TODO: Add support for "review" types
+                throw new UnsupportedOperationException(
+                        "Unsupported component space" + space);
+        }
+    }
+
+    private ComponentRegistry getGroupRegistry(Number groupId, Owner owner, UserCredentials credentials) {
+        if (owner == null || owner instanceof OwnerUser) {
+            RegistryUser user = this.getOrCreateUser(credentials);
+            owner = new OwnerUser(user.getId());
+        }
+        ComponentRegistryDbImpl cr = componentRegistryBeanFactory.getNewComponentRegistry();// default public registry
+        cr.setRegistrySpace(RegistrySpace.PRIVATE);
+        cr.setRegistryOwner(owner);
+        cr.setGroupId(groupId);
+        return cr;
     }
 
     private ComponentRegistry getPrivateRegistry(Owner owner,
-	    UserCredentials credentials) throws IllegalArgumentException,
-	    DataAccessException, UserUnauthorizedException {
-	if (owner == null || owner instanceof OwnerUser) {
-	    RegistryUser user = getOrCreateUser(credentials);
-	    if (user != null) {
-		if (owner != null && !user.getId().equals(owner.getId())) {
-		    throw new UserUnauthorizedException(
-			    "User cannot access other user's private registry");
-		}
-
-		try {
-		    return getNewComponentRegistryForUser(user.getId());
-		} catch (DataAccessException ex) {
-		    LOG.error("Could not retrieve or create user", ex);
-		    throw ex;
-		}
-	    } else {
-		throw new UserUnauthorizedException(
-			"No user credentials available cannot load userspace.");
-	    }
-	} else {
-	    // TODO: Support group owners
-	    throw new UnsupportedOperationException(
-		    "Group owners not supported");
-	}
+            UserCredentials credentials) throws IllegalArgumentException,
+            DataAccessException, UserUnauthorizedException {
+        if (owner == null || owner instanceof OwnerUser) {
+            RegistryUser user = getOrCreateUser(credentials);
+            if (user != null) {
+                if (owner != null && !user.getId().equals(owner.getId())) {
+                    throw new UserUnauthorizedException(
+                            "User cannot access other user's private registry");
+                }
+
+                try {
+                    return this.getNewComponentRegistryForUser(user.getId());
+                } catch (DataAccessException ex) {
+                    LOG.error("Could not retrieve or create user", ex);
+                    throw ex;
+                }
+            } else {
+                throw new UserUnauthorizedException(
+                        "No user credentials available cannot load userspace.");
+            }
+        } else {
+            // TODO: Support group owners
+            throw new UnsupportedOperationException(
+                    "Group owners not supported");
+        }
     }
 
     @Override
     public ComponentRegistry getOtherUserComponentRegistry(
-	    Principal adminPrincipal, ComponentStatus status, Owner owner) {
-	try {
-	    RegistryUser user;
-	    if (owner instanceof OwnerUser) {
-		user = userDao.findOne(owner.getId().longValue());
-	    } else {
-		// TODO: Implement for groups
-		throw new UnsupportedOperationException(
-			"Groups not implemented yet");
-	    }
-	    ComponentRegistry result = null;
-	    if (user != null) {
-		if (configuration.isAdminUser(adminPrincipal)) {
-		    result = getNewComponentRegistryForUser(user.getId());
-		} else {
-		    LOG.info("{} not found in list of {}",
-			    adminPrincipal.getName(),
-			    configuration.getAdminUsersArray().length);
-		    throw new IllegalArgumentException("User "
-			    + adminPrincipal.getName()
-			    + " is not admin user cannot load userspace.");
-		}
-	    }
-	    return result;
-	} catch (DataAccessException ex) {
-	    LOG.error("Could not retrieve user by id", ex);
-	    throw ex;
-	}
+            Principal adminPrincipal, Owner owner) {
+        try {
+            RegistryUser user;
+            if (owner instanceof OwnerUser) {
+                user = userDao.findOne(owner.getId().longValue());
+            } else {
+                // TODO: Implement for groups ??? Twan
+                throw new UnsupportedOperationException(
+                        "Groups not implemented yet");
+            }
+            ComponentRegistry result = null;
+            if (user != null) {
+                if (configuration.isAdminUser(adminPrincipal)) {
+                    result = this.getNewComponentRegistryForUser(user.getId());
+                } else {
+                    LOG.info("{} not found in list of {}",
+                            adminPrincipal.getName(),
+                            configuration.getAdminUsersArray().length);
+                    throw new IllegalArgumentException("User "
+                            + adminPrincipal.getName()
+                            + " is not admin user cannot load userspace.");
+                }
+            }
+            return result;
+        } catch (DataAccessException ex) {
+            LOG.error("Could not retrieve user by id", ex);
+            throw ex;
+        }
     }
 
     @Override
     public ComponentRegistry getPublicRegistry() {
-	if (publicComponentRegistry == null) {
-	    publicComponentRegistry = getNewComponentRegistryForUser(null);
-	}
-	return publicComponentRegistry;
+        if (publicComponentRegistry == null) {
+            publicComponentRegistry = this.getNewComponentRegistryForUser(null);
+        }
+        return publicComponentRegistry;
     }
 
     private ComponentRegistry getNewComponentRegistryForUser(Number userId) {
-	ComponentRegistryDbImpl componentRegistry = componentRegistryBeanFactory
-		.getNewComponentRegistry();
-	if (userId != null) {
-	    // Null means public registry
-	    // TODO: Make this more explicit
-	    componentRegistry.setStatus(ComponentStatus.PRIVATE, new OwnerUser(
-		    userId));
-	}
-	return componentRegistry;
+        ComponentRegistryDbImpl componentRegistry = componentRegistryBeanFactory.getNewComponentRegistry();
+        if (userId != null) {
+            OwnerUser ou = new OwnerUser(userId);
+            componentRegistry.setRegistrySpace(RegistrySpace.PRIVATE);
+            componentRegistry.setRegistryOwner(ou);
+            componentRegistry.setGroupId(null);
+        }
+        return componentRegistry;
+    }
+
+    @Override
+    public ComponentRegistryDbImpl getBaseRegistry(UserCredentials credentials) {
+        RegistryUser user = this.getOrCreateUser(credentials);
+        ComponentRegistryDbImpl componentRegistryDbImpl = componentRegistryBeanFactory.getNewComponentRegistry();// default public registry
+        if (user != null) {
+            Number userId = user.getId();
+            Owner owner = new OwnerUser(userId);
+            componentRegistryDbImpl.setRegistrySpace(null);
+            componentRegistryDbImpl.setRegistryOwner(owner);
+            componentRegistryDbImpl.setGroupId(null);
+        }
+        return componentRegistryDbImpl;
     }
 
     @Override
     public RegistryUser getOrCreateUser(UserCredentials credentials) {
-	if (credentials != null
-		&& !ANONYMOUS_USER.equals(credentials.getPrincipalName())) {
-	    String principalName = credentials.getPrincipalName();
-	    return getOrCreateUser(principalName, credentials.getDisplayName());
-	}
-	return null;
+        if (credentials != null
+                && !ANONYMOUS_USER.equals(credentials.getPrincipalName())) {
+            String principalName = credentials.getPrincipalName();
+            return this.getOrCreateUser(principalName, credentials.getDisplayName());
+        }
+        return null;
     }
 
     private synchronized RegistryUser getOrCreateUser(String principalName,
-	    String displayName) {
-	// Try getting it from db
-	RegistryUser user = userDao.getByPrincipalName(principalName);
-	if (user == null) {
-	    LOG.info(
-		    "Request to create user with principal name {} and display name {}",
-		    new Object[] { principalName, displayName });
-	    // Create the new user
-	    user = new RegistryUser();
-	    user.setPrincipalName(principalName);
-	    user.setName(displayName);
-	    userDao.saveAndFlush(user);
-	    // Retrieve from db
-	    user = userDao.getByPrincipalName(principalName);
-	}
-	return user;
+            String displayName) {
+        // Try getting it from db
+        RegistryUser user = userDao.getByPrincipalName(principalName);
+        if (user == null) {
+            LOG.info(
+                    "Request to create user with principal name {} and display name {}",
+                    new Object[]{principalName, displayName});
+            // Create the new user
+            user = new RegistryUser();
+            user.setPrincipalName(principalName);
+            user.setName(displayName);
+            userDao.saveAndFlush(user);
+            // Retrieve from db
+            user = userDao.getByPrincipalName(principalName);
+        }
+        return user;
     }
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/GroupService.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/GroupService.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/GroupService.java	(revision 5549)
@@ -1,4 +1,5 @@
 package clarin.cmdi.componentregistry.impl.database;
 
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import java.util.List;
 
@@ -95,5 +96,5 @@
      * @param componentId
      */
-    void transferItemOwnershipFromUserToGroup(String principal, String groupId, String componentId);
+    void transferItemOwnershipFromUserToGroup(String principal, String groupId, String componentId) throws UserUnauthorizedException;
 
     /**
@@ -103,5 +104,5 @@
      * @param componentId
      */
-    void transferItemOwnershipFromUserToGroupId(String principal, long groupId, String componentId);
+    void transferItemOwnershipFromUserToGroupId(String principal, long groupId, String componentId) throws UserUnauthorizedException;
 
     /**
@@ -126,4 +127,6 @@
      */
     List<String> getProfileIdsInGroup(long groupId);
-
+    
+    boolean userGroupMember(String principalName, String groupId);
+   
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/GroupServiceImpl.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/GroupServiceImpl.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/GroupServiceImpl.java	(revision 5549)
@@ -1,4 +1,5 @@
 package clarin.cmdi.componentregistry.impl.database;
 
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import java.util.ArrayList;
 import java.util.Collections;
@@ -235,6 +236,7 @@
 		ownerships.addAll(ownershipDao.findOwnershipByComponentId(itemId));
 		Set<Group> groups = new HashSet<Group>();
-		for (Ownership ownership : ownerships)
+		for (Ownership ownership : ownerships) {
 			groups.add(groupDao.findOne(ownership.getGroupId()));
+                }
 		List<Group> groupList = new ArrayList<Group>(groups);
 		Collections.sort(groupList, new Comparator<Group>() {
@@ -247,4 +249,6 @@
 		return groupList;
 	}
+        
+        
 
 	@ManagedOperation(description = "Make a component owned by a group instead of a user")
@@ -254,13 +258,27 @@
 			@ManagedOperationParameter(name = "componentId", description = "Id of component") })
 	@Override
-	public void transferItemOwnershipFromUserToGroup(String principal, String groupName, String itemId) {
-
+	public void transferItemOwnershipFromUserToGroup(String principal, String groupName, String itemId) throws UserUnauthorizedException{
+                
+                           
 		BaseDescription item = null;
 		item = componentDao.getByCmdId(itemId);
-		if (item == null)
+		if (item == null) {
 			throw new ValidationException("No profile or component found with ID " + itemId);
+                }
 		Group group = groupDao.findGroupByName(groupName);
-		if (group == null)
+		if (group == null) {
 			throw new ValidationException("No group found with name " + groupName);
+                }
+                
+                if (!this.userGroupMember(principal, String.valueOf(group.getId()))) {
+                   throw new UserUnauthorizedException("User " + principal+ " is not a member of group "+groupName); 
+                }
+                
+                String creatorName = item.getCreatorName();
+                if (!creatorName.equals(principal)) {
+                   throw new UserUnauthorizedException("User " + principal+ " is not creator of the item  "+item.getName()); 
+                }
+                
+                
 		Ownership ownership = null;
 		List<Ownership> oldOwnerships = ownershipDao.findOwnershipByComponentId(itemId);
@@ -273,10 +291,17 @@
 
 	@Override
-	public void transferItemOwnershipFromUserToGroupId(String principal, long groupId, String componentId) {
+	public void transferItemOwnershipFromUserToGroupId(String principal, long groupId, String componentId) throws UserUnauthorizedException{
 		Group group = groupDao.findOne(groupId);
-		if (group == null)
+		if (group == null) {
 			throw new ValidationException("No group found with id " + groupId);
-		transferItemOwnershipFromUserToGroup(principal, group.getName(), componentId);
-	}
-
+                }
+		this.transferItemOwnershipFromUserToGroup(principal, group.getName(), componentId);
+	}
+
+        @Override
+        public boolean userGroupMember(String principalName, String groupId) {
+            RegistryUser user = userDao.getByPrincipalName(principalName);
+            GroupMembership gm = groupMembershipDao.findMembership(user.getId(), Long.parseLong(groupId));
+            return gm != null;
+        }
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/ComponentDao.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/ComponentDao.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/ComponentDao.java	(revision 5549)
@@ -16,11 +16,5 @@
 public interface ComponentDao {
 
-    /**
-     * Get all public components
-     * 
-     * @return
-     */
-    List<BaseDescription> getPublicComponentDescriptions();
-
+    
     /**
      * Get all public profiles
@@ -28,5 +22,5 @@
      * @return
      */
-    List<BaseDescription> getPublicProfileDescriptions();
+    List<BaseDescription> getPublicBaseDescriptions(String prefix);
 
     /**
@@ -57,5 +51,5 @@
      *         public)
      */
-    boolean isInRegistry(String cmdId, Number userId);
+    //boolean isAccessible(String cmdId, Number userId);
 
     /**
@@ -117,6 +111,7 @@
      * @return The description, if it exists; null otherwise
      */
-    BaseDescription getByCmdId(String id, Number userId)
-	    throws DataAccessException;
+//    BaseDescription getByCmdId(String id, Number userId)
+//	    throws DataAccessException;
+ 
 
     /**
@@ -146,15 +141,7 @@
      *         not part of any group
      */
-    List<BaseDescription> getUserspaceComponents(Number userId)
+    List<BaseDescription> getPrivateBaseDescriptions(Number userId, String prefix)
 	    throws DataAccessException;
-
-    /**
-     * 
-     * @return All the user's profiles not in the public space and are also
-     *         not part of any group
-     */
-    List<BaseDescription> getUserspaceProfiles(Number userId)
-	    throws DataAccessException;
-
+  
     void setDeleted(BaseDescription desc, boolean isDeleted)
 	    throws DataAccessException;
@@ -182,4 +169,8 @@
     List<String> getAllNonDeletedComponentIds();
 
+    public List<BaseDescription> getAllNonDeletedDescriptions();
+            
+    // Olha was here
+    public List<String> getAllItemIdsInGroup(String prefix, Long groupId);
 
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/impl/ComponentDaoImpl.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/impl/ComponentDaoImpl.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/impl/ComponentDaoImpl.java	(revision 5549)
@@ -110,6 +110,7 @@
      */
     private List<BaseDescription> augment(List<BaseDescription> baseDescription) {
-	if (baseDescription.isEmpty())
+	if (baseDescription.isEmpty()) {
 	    return baseDescription;
+        }
 	Map<String, BaseDescription> map = new HashMap<String, BaseDescription>();
 	List<String> idlist = new ArrayList<String>();
@@ -165,12 +166,12 @@
      *         public)
      */
-    @Override
-    public boolean isInRegistry(String cmdId, Number userId) {
-	if (userId == null) {
-	    return isPublic(cmdId);
-	} else {
-	    return isInUserSpace(cmdId, userId);
-	}
-    }
+//    @Override
+//    public boolean isAccessible(String cmdId, Number userId) {
+//	if (userId == null) {
+//	    return this.isPublic(cmdId);
+//	} else {
+//	    return this.isInUserSpace(cmdId, userId);
+//	}
+//    }
 
     /**
@@ -207,4 +208,5 @@
 	copy.setPublic(isPublic);
 	copy.setUserId(toString(userId));
+        copy.setCreatorName(description.getCreatorName());
 	copy = jpaComponentDao.saveAndFlush(copy);
 	jpaComponentDao.updateContent(copy.getId(), content);
@@ -278,30 +280,5 @@
     }
 
-    /**
-     * Get by ComponentId / ProfileId
-     * 
-     * @param id
-     *            Full component id
-     * @param userId
-     *            Db id of user for workspace; null for public space
-     * @return The description, if it exists; null otherwise
-     */
-    @Override
-    public BaseDescription getByCmdId(String id, Number userId) {
-	BaseDescription baseDescription = getByCmdId(id);
-	if (baseDescription != null) {
-	    augment(baseDescription);
-	    if (userId == null) {
-		if (!baseDescription.isPublic())
-		    baseDescription = null;
-	    } else {
-		if (baseDescription.isPublic()
-			|| !compare(baseDescription.getUserId(), userId))
-		    baseDescription = null;
-	    }
-	}
-	return baseDescription;
-    }
-
+  
     /**
      * 
@@ -352,16 +329,10 @@
      */
     @Override
-    public List<BaseDescription> getUserspaceComponents(Number userId) {
-	return augment(jpaComponentDao
-		.findItemsForUserThatAreNotInGroups(userId.longValue(),
-			ComponentDescription.COMPONENT_PREFIX + "%"));
-    }
-
-    @Override
-    public List<BaseDescription> getUserspaceProfiles(Number userId) {
-	return augment(jpaComponentDao.findItemsForUserThatAreNotInGroups(
-		userId.longValue(), ProfileDescription.PROFILE_PREFIX + "%"));
-    }
-
+    public List<BaseDescription> getPrivateBaseDescriptions(Number userId, String prefix) {
+        return augment(jpaComponentDao.findItemsForUserThatAreNotInGroups(userId.longValue(),prefix + "%"));
+	//return augment(jpaComponentDao.findNotPublishedUserItems(userId.longValue(),prefix + "%"));
+    }
+
+   
     @Override
     public void setDeleted(BaseDescription desc, boolean isDeleted) {
@@ -399,15 +370,9 @@
 
     @Override
-    public List<BaseDescription> getPublicComponentDescriptions() {
-	return augment(jpaComponentDao
-		.findPublicItems(ComponentDescription.COMPONENT_PREFIX + "%"));
-    }
-
-    @Override
-    public List<BaseDescription> getPublicProfileDescriptions() {
-	return augment(jpaComponentDao
-		.findPublicItems(ProfileDescription.PROFILE_PREFIX + "%"));
-    }
-
+    public List<BaseDescription> getPublicBaseDescriptions(String prefix) {
+	return augment(jpaComponentDao.findPublishedItems(prefix + "%"));
+    }
+
+   
     @Override
     public List<String> getAllNonDeletedProfileIds() {
@@ -419,4 +384,17 @@
 	return jpaComponentDao.findNonDeletedItemIds(ComponentDescription.COMPONENT_PREFIX+"%");
     }
-
+    
+    @Override
+    public List<BaseDescription> getAllNonDeletedDescriptions() {
+	return jpaComponentDao.findNonDeletedDescriptions();
+    }
+    
+    // Olha was here
+    @Override
+    public List<String> getAllItemIdsInGroup(String prefix, Long groupId) {
+        // we are ineterested only in non-published components in the group
+	return jpaComponentDao.findAllItemIdsInGroup(false, prefix + "%", groupId);
+    }
+    
+   
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/CommentsDao.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/CommentsDao.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/CommentsDao.java	(revision 5549)
@@ -35,5 +35,5 @@
 	 */
     	@Query("select c from Comment c where c.componentId = ?1 order by c.commentDate, c.id")
-	List<Comment> getCommentsFromComponent(String componentId)
+	List<Comment> getCommentsFromItem(String componentId)
 			throws DataAccessException;
 
@@ -44,5 +44,6 @@
 	 * @return Principal name of description's owner, if any. Otherwise, null.
 	 */
-    	@Query("select user from RegistryUser user, Comment comment, BaseDescription component where comment.id = ?1 and comment.componentId = component.componentId and component.dbUserId = user.id")
+    	//@Query("select user from RegistryUser user, Comment comment, BaseDescription component where comment.id = ?1 and comment.componentId = component.componentId and component.dbUserId = user.id")
+	@Query("select user from RegistryUser user, Comment comment where comment.id = ?1 and user.id=comment.userId")
 	RegistryUser getOwnerOfComment(long id);
 
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/JpaComponentDao.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/JpaComponentDao.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/JpaComponentDao.java	(revision 5549)
@@ -25,5 +25,5 @@
 
     @Query("select c from BaseDescription c where c.ispublic = true and c.deleted = false and c.componentId like ?1 order by upper(c.name) asc")
-    List<BaseDescription> findPublicItems(String idPrefix);
+    List<BaseDescription> findPublishedItems(String idPrefix);
 
     @Query("select c from BaseDescription c where c.ispublic = false and c.deleted = true and c.dbUserId = ?1 order by upper(c.name), c.id")
@@ -33,4 +33,5 @@
     List<BaseDescription> findPublicDeletedItems();
     
+    //compare @Query("select c from BaseDescription c where c.dbUserId = ?1 AND c.deleted = false AND c.ispublic = false AND c.componentId like ?2 order by upper(c.name), c.id")
     @Query("select c from BaseDescription c where c.dbUserId = ?1 AND c.deleted = false AND c.ispublic = false AND c.componentId like ?2 AND not exists (select 1 from Ownership o where o.componentId = c.componentId) order by upper(c.name), c.id")
     List<BaseDescription> findItemsForUserThatAreNotInGroups(Long userId, String idPrefix);
@@ -48,4 +49,12 @@
     @Query("select c.componentId from BaseDescription c where c.deleted = false and c.componentId like ?1 order by c.id asc")
     List<String> findNonDeletedItemIds(String componentIdPrefix);
+    
+    @Query("select c from BaseDescription c where c.deleted = false order by c.id asc")
+    List<BaseDescription> findNonDeletedDescriptions();
 
+    @Query("select c from BaseDescription c where c.dbUserId = ?1 AND c.deleted = false AND c.ispublic = false AND c.componentId like ?2 order by upper(c.name), c.id")
+    List<BaseDescription> findNotPublishedUserItems(Long userId, String idPrefix);    
+    
+    @Query("select c.componentId from BaseDescription c where c.ispublic = ?1 AND c.componentId like ?2 AND exists (select o from Ownership o where o.componentId = c.componentId AND o.groupId = ?3)")
+    List<String> findAllItemIdsInGroup(boolean isPublished, String idPrefix, long groupId);
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/UserDao.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/UserDao.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/persistence/jpa/UserDao.java	(revision 5549)
@@ -28,4 +28,7 @@
 	RegistryUser getByPrincipalName(String principalName)
 			throws DataAccessException;
+        
+        @Query("select u from RegistryUser u where u.id = ?1")
+	RegistryUser getPrincipalNameById(Number id) throws DataAccessException;
 
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ComponentClosure.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ComponentClosure.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ComponentClosure.java	(revision 5549)
@@ -3,4 +3,6 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.model.ComponentDescription;
 
@@ -8,6 +10,6 @@
 
     @Override
-    public ComponentDescription getDescription(ComponentRegistry registry, String id) throws ComponentRegistryException {
-        return registry.getComponentDescription(id);
+    public ComponentDescription getDescription(ComponentRegistry registry, String id) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException {
+        return registry.getComponentDescriptionAccessControlled(id);
     }
 
